#ifndef ISC0901_H
#define ISC0901_H

#include "xparameters.h"

/* Definitions for ISC0901_ctrl register addresses */
#define ISC0901_CTRL_REG_ADDR        XPAR_ISC0901_CTRL_0_BASEADDR + 0*4
#define ISC0901_BIAS_BUF_ADDR_ADDR   XPAR_ISC0901_CTRL_0_BASEADDR + 1*4
#define ISC0901_RTEMP_BUF_ADDR_ADDR  XPAR_ISC0901_CTRL_0_BASEADDR + 2*4
#define ISC0901_CMD_BUF_ADDR_ADDR    XPAR_ISC0901_CTRL_0_BASEADDR + 3*4
#define ISC0901_BIAS_BTT_ADDR        XPAR_ISC0901_CTRL_0_BASEADDR + 4*4
#define ISC0901_RTEMP_BTT_ADDR       XPAR_ISC0901_CTRL_0_BASEADDR + 5*4
#define ISC0901_CMD_BTT_ADDR         XPAR_ISC0901_CTRL_0_BASEADDR + 6*4

#define SENSOR_BIAS_VOLT_SEL        1
#define SENSOR_BIAS_BOOST_PWR_ENA   2
#define SENSOR_BIAS_PWR_ENA         3
#define SENSOR_CORE_PWR_ENA         4
//SENSOR_IO_PWR_ENA_N[5] is double inverted
#define SENSOR_IO_PWR_ENA           5
#define SENSOR_RSTN                 6
#define ISC0901_RESET_N             31

void init_ISC0901();
void disable_ISC0901();

#endif