#include "dip.h"

#include "xparameters.h"
#include "xil_io.h"
#include "ram_address.h"

void init_dip()
{
    int i;

    //NUC disabled for first test
    //Set gain values to some value    
    for(i=0; i<336*256; i++)
    {
        Xil_Out16(RAM_DIP_GAIN_BUF_ADDR+i*2, 8000);
    }

    //Set offset values to some value    
    for(i=0; i<336*256; i++)
    {
        Xil_Out16(RAM_DIP_OFST_BUF_ADDR+i*2, 1000);
    }

    Xil_Out32(DIP_CTRL_REG_ADDR, 0x0000);    
    Xil_Out32(DIP_RAW_BUF_ADDR_ADDR, RAM_DIP_RAW_BUF_ADDR);
    Xil_Out32(DIP_RAW_BTT_ADDR, RAM_DIP_RAW_BTT);
    Xil_Out32(DIP_AVG_BUF_ADDR_ADDR, RAM_DIP_AVG_BUF_ADDR);
    Xil_Out32(DIP_AVG_BTT_ADDR, RAM_DIP_AVG_BTT);
    Xil_Out32(DIP_GAIN_BUF_ADDR_ADDR, RAM_DIP_GAIN_BUF_ADDR);
    Xil_Out32(DIP_GAIN_BTT_ADDR, RAM_DIP_GAIN_BTT);
    Xil_Out32(DIP_OFST_BUF_ADDR_ADDR, RAM_DIP_OFST_BUF_ADDR);
    Xil_Out32(DIP_OFST_BTT_ADDR, RAM_DIP_OFST_BTT);
    Xil_Out32(DIP_EQUAL_BUF_ADDR_ADDR, RAM_DIP_EQUAL_BUF_ADDR);
    Xil_Out32(DIP_EQUAL_BTT_ADDR, RAM_DIP_EQUAL_BTT);
    Xil_Out32(DIP_EQUAL2_BUF_ADDR_ADDR, RAM_DIP_EQUAL2_BUF_ADDR);
    Xil_Out32(DIP_EQUAL2_BTT_ADDR, RAM_DIP_EQUAL2_BTT);

    Xil_Out32(DIP_CTRL_REG_ADDR, (1<<DIP_RESET_N) | (1<<BPR_BYPASS) | (1<<NUC_BYPASS) |(1<<EQUAL_FIFO_LOAD_ENA) | (1<<RAW_FIFO_LOAD_REQ));
}

void disable_dip()
{
    Xil_Out32(DIP_CTRL_REG_ADDR, 0x0000); 
}

int read_dip_stat_reg()
{
    return Xil_In32(DIP_STAT_REG_ADDR);    
}