#ifndef DIP_H
#define DIP_H

/* Definitions for ISC0901_ctrl register addresses */
#define DIP_CTRL_REG_ADDR               XPAR_DIP_DIP_CTRL_BASEADDR + 0*4
#define DIP_STAT_REG_ADDR               XPAR_DIP_DIP_CTRL_BASEADDR + 1*4
//RAW = 16bit, 14bit relvant for every pixel
#define DIP_RAW_BUF_ADDR_ADDR           XPAR_DIP_DIP_CTRL_BASEADDR + 2*4
//AVG = 16bit, 14bit relvant for every pixel
#define DIP_AVG_BUF_ADDR_ADDR           XPAR_DIP_DIP_CTRL_BASEADDR + 3*4
//Gain = 16bit for every pixel
#define DIP_GAIN_BUF_ADDR_ADDR          XPAR_DIP_DIP_CTRL_BASEADDR + 4*4
//Offset = 16bit for every pixel
#define DIP_OFST_BUF_ADDR_ADDR          XPAR_DIP_DIP_CTRL_BASEADDR + 5*4
//EQUAL = 16bit, 14bit relvant for every pixel
#define DIP_EQUAL_BUF_ADDR_ADDR         XPAR_DIP_DIP_CTRL_BASEADDR + 6*4
//EQUAL2 = 16bit, 14bit relvant for every pixel
#define DIP_EQUAL2_BUF_ADDR_ADDR        XPAR_DIP_DIP_CTRL_BASEADDR + 7*4
#define DIP_RAW_BTT_ADDR                XPAR_DIP_DIP_CTRL_BASEADDR + 8*4
#define DIP_AVG_BTT_ADDR                XPAR_DIP_DIP_CTRL_BASEADDR + 9*4
#define DIP_GAIN_BTT_ADDR               XPAR_DIP_DIP_CTRL_BASEADDR + 10*4
#define DIP_OFST_BTT_ADDR               XPAR_DIP_DIP_CTRL_BASEADDR + 11*4
#define DIP_EQUAL_BTT_ADDR              XPAR_DIP_DIP_CTRL_BASEADDR + 12*4
#define DIP_EQUAL2_BTT_ADDR             XPAR_DIP_DIP_CTRL_BASEADDR + 13*4

#define RAW_FIFO_LOAD_REQ           0
#define EQUAL_FIFO_LOAD_ENA         1
//AVG level 3bit, 0=off, 1=2x, 2=4x, 3=8x, 4=16x, 5=32x, 6=64x, 7=128x
#define AVG_LEVEL                   8
#define NUC_BYPASS                  11
#define BPR_BYPASS                  12
#define DIP_RESET_N                 31

void init_dip();
void disable_dip();
int read_dip_stat_reg();

#endif