#ifndef _LCD_H
#define _LCD_H

#include <stdint.h>
#include "xparameters.h"
#include "ram_address.h"

#define LCD_WIDTH 320
#define LCD_HEIGHT 240

#define BLUE    0x001f
#define GREEN   0x07e0
#define RED     0xf800
#define YELLOW  0xffe0
#define WHITE   0xffff
#define BLACK   0x0000

#define LCD_BUFFER_ADDRESS  RAM_CH1_PING_ADDR

void set_pixel(uint16_t pos_x, uint16_t pos_y, uint16_t color);
void fill_rect(uint16_t start_x, uint16_t start_y, uint16_t end_x, uint16_t end_y, uint16_t color);
void lcd_drawLine(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint16_t color);
void lcd_drawCircle(uint16_t center_x, uint16_t center_y, uint16_t radius, uint16_t color);
void lcd_fillCircle(uint16_t center_x, uint16_t center_y, uint16_t radius, uint16_t color);
void lcd_glyph(uint16_t x, uint16_t y, uint8_t width, uint8_t height, char *glyph_ptr, uint8_t store_width);
void lcd_text_intern(uint16_t left, uint16_t top, uint8_t font, char *string_ptr);
void lcd_text(uint16_t left, uint16_t top, uint8_t font, char *string_ptr);

#endif