/* This file is automatically generated based on your hardware design. */
#include "memory_config.h"

#include "xparameters.h"
#include "xil_testmem.h"
#include "xstatus.h"
#include "xil_printf.h"
#include <stdio.h>

int n_memory_ranges = 2;

struct memory_range_s memory_ranges[] = {
	/* microblaze_0_local_memory_dlmb_bram_if_cntlr_Mem memory will not be tested since application resides in the same memory */
	{
		"OpenHBMC_0_Mem",
		"OpenHBMC_0",
		XPAR_OPENHBMC_0_BASEADDR,
		8388608,
	},
	{
		"OpenHBMC_1_Mem",
		"OpenHBMC_1",
		XPAR_OPENHBMC_1_BASEADDR,
		8388608,
	},
};

void test_memory_range(struct memory_range_s *range) {
    XStatus status;

    /* This application uses print statements instead of xil_printf/printf
     * to reduce the text size.
     *
     * The default linker script generated for this application does not have
     * heap memory allocated. This implies that this program cannot use any
     * routines that allocate memory on heap (printf is one such function).
     * If you'd like to add such functions, then please generate a linker script
     * that does allocate sufficient heap memory.
     */

    print("Testing memory region: "); print(range->name);  print("\r");
    print("    Memory Controller: "); print(range->ip);  print("\r");
    #if defined(__MICROBLAZE__) && !defined(__arch64__)
        print("         Base Address: 0x"); putnum(range->base); print("\r");
        print("                 Size: 0x"); putnum(range->size); print (" bytes \r");
    #else
        xil_printf("         Base Address: 0x%lx \n\r",range->base);
        xil_printf("                 Size: 0x%lx bytes \n\r",range->size);
    #endif

    status = Xil_TestMem32((u32*)range->base, 1024, 0xAAAA5555, XIL_TESTMEM_ALLMEMTESTS);
    print("          32-bit test: "); print(status == XST_SUCCESS? "PASSED!":"FAILED!"); print("\r");

    status = Xil_TestMem16((u16*)range->base, 2048, 0xAA55, XIL_TESTMEM_ALLMEMTESTS);
    print("          16-bit test: "); print(status == XST_SUCCESS? "PASSED!":"FAILED!"); print("\r");

    status = Xil_TestMem8((u8*)range->base, 4096, 0xA5, XIL_TESTMEM_ALLMEMTESTS);
    print("           8-bit test: "); print(status == XST_SUCCESS? "PASSED!":"FAILED!"); print("\r");
}

void run_memory_test(){
    int i;

    print("--Starting Memory Test Application--\r");
    print("NOTE: This application runs with D-Cache disabled.");
    print("As a result, cacheline requests will not be generated\r");
    for (i = 0; i < n_memory_ranges; i++) {
        test_memory_range(&memory_ranges[i]);
    }
    print("--Memory Test Application Complete--\r");
    print("Successfully ran Memory Test Application\n\r");
    

    print("Hello World\r");
    print("Successfully ran Hello World application\r");
}