#ifndef __PORT_H_
#define __PORT_H_

#include "xparameters.h"
#include "xgpio.h"

extern XGpio Gpio;

#define LED_GREEN   7
#define LED_RED     6
#define LED_CHANNEL 1
#define PWR_OFF_REQ 0

#define LED_GREEN_ON()      XGpio_DiscreteSet(&Gpio, LED_CHANNEL, 1<<LED_GREEN);XGpio_DiscreteClear(&Gpio, LED_CHANNEL, 1<<LED_RED)
#define LED_GREEN_OFF()     XGpio_DiscreteClear(&Gpio, LED_CHANNEL, 1<<LED_GREEN)
#define LED_RED_ON()        XGpio_DiscreteSet(&Gpio, LED_CHANNEL, 1<<LED_RED);XGpio_DiscreteClear(&Gpio, LED_CHANNEL, 1<<LED_GREEN)
#define LED_RED_OFF()       XGpio_DiscreteClear(&Gpio, LED_CHANNEL, 1<<LED_RED)
#define PWR_OFF_REQ_OFF()   XGpio_DiscreteClear(&Gpio, LED_CHANNEL, 1<<PWR_OFF_REQ)
#define PWR_OFF_REQ_ON()    XGpio_DiscreteSet(&Gpio, LED_CHANNEL, 1<<PWR_OFF_REQ)

//Level = 0-31
//#define LCD_LED_LEVEL()    XGpio_DiscreteClear(&Gpio, LED_CHANNEL, 1<<5);XGpio_DiscreteClear(&Gpio, LED_CHANNEL, 1<<4);XGpio_DiscreteWrite(&Gpio, LED_CHANNEL, 1<<3);XGpio_DiscreteWrite(&Gpio, LED_CHANNEL, 1<<2);XGpio_DiscreteWrite(&Gpio, LED_CHANNEL, 1<<1)
#define LCD_LED_LEVEL(value)    XGpio_DiscreteClear(&Gpio, LED_CHANNEL, ~(value<<1));XGpio_DiscreteSet(&Gpio, LED_CHANNEL, (value<<1))
void init_ports();

#endif