#ifndef RAM_ADDRESS_H
#define RAM_ADDRESS_H

#include "xparameters.h"

//Sensor resolution 336 x 256
//mapping everything to RAM0 to eventually use RAM1 for Microblaze system

//Bias 8bit per pixel (sending 7bit) only first 6bit relevant, approximate value is about ~0x25
#define RAM_BIAS_BUF_ADDR       XPAR_OPENHBMC_0_BASEADDR
#define RAM_BIAS_BTT            336
//Rtemp 16bit per pixel, only 14bit relevant
#define RAM_RTEMP_BUF_ADDR      XPAR_OPENHBMC_0_BASEADDR+336*256*2*1
#define RAM_RTEMP_BTT           336
//cmd = {CMD_SIZE * 8{1'b0}}, CMD_SIZE=20, 20*8=160bit
#define RAM_CMD_BUF_ADDR        XPAR_OPENHBMC_0_BASEADDR+336*256*2*2
#define RAM_CMD_BTT             20

//sensor raw image row
#define RAM_DIP_RAW_BUF_ADDR    XPAR_OPENHBMC_0_BASEADDR+336*256*2*3
#define RAM_DIP_RAW_BTT         336
//averaging output row
#define RAM_DIP_AVG_BUF_ADDR    XPAR_OPENHBMC_0_BASEADDR+336*256*2*4
#define RAM_DIP_AVG_BTT         336
//sensor NUC gain row
#define RAM_DIP_GAIN_BUF_ADDR   XPAR_OPENHBMC_0_BASEADDR+336*256*2*5
#define RAM_DIP_GAIN_BTT        336
//sensor NUC offset row
#define RAM_DIP_OFST_BUF_ADDR   XPAR_OPENHBMC_0_BASEADDR+336*256*2*6
#define RAM_DIP_OFST_BTT        336
//equalized image row
#define RAM_DIP_EQUAL_BUF_ADDR  XPAR_OPENHBMC_0_BASEADDR+336*256*2*7
#define RAM_DIP_EQUAL_BTT       84
//equalized image row (x2 upscaled)
#define RAM_DIP_EQUAL2_BUF_ADDR XPAR_OPENHBMC_0_BASEADDR+336*256*2*8
#define RAM_DIP_EQUAL2_BTT      336

//LCD stream, 8bit color per pixel through heatmap?
#define RAM_CH0_PING_ADDR   RAM_DIP_RAW_BUF_ADDR
#define RAM_CH0_PONG_ADDR   RAM_DIP_EQUAL_BUF_ADDR
#define RAM_CH0_BUF_SIZE    320*240
#define RAM_CH0_BTT         320

//LCD OSD only has 16-bit
#define RAM_CH1_PING_ADDR   XPAR_OPENHBMC_0_BASEADDR+336*256*2*10
#define RAM_CH1_PONG_ADDR   XPAR_OPENHBMC_0_BASEADDR+336*256*2*10+320*240*2
#define RAM_CH1_BUF_SIZE    320*240*2
#define RAM_CH1_BTT         320

/*
//Bias 8bit per pixel (sending 7bit) only first 6bit relevant, approximate value is about ~0x25
#define RAM_BIAS_BUF_ADDR       XPAR_OPENHBMC_0_BASEADDR
#define RAM_BIAS_BTT            336
//Rtemp 16bit per pixel, only 14bit relevant
#define RAM_RTEMP_BUF_ADDR      XPAR_OPENHBMC_0_BASEADDR+336*256*2*1
#define RAM_RTEMP_BTT           336
//cmd = {CMD_SIZE * 8{1'b0}}, CMD_SIZE=20, 20*8=160bit
#define RAM_CMD_BUF_ADDR        XPAR_OPENHBMC_0_BASEADDR+336*256*2*2
#define RAM_CMD_BTT             20

//sensor raw image row
#define RAM_DIP_RAW_BUF_ADDR    XPAR_OPENHBMC_0_BASEADDR+336*256*2*3
#define RAM_DIP_RAW_BTT         168
//averaging output row
#define RAM_DIP_AVG_BUF_ADDR    XPAR_OPENHBMC_0_BASEADDR+336*256*2*4
#define RAM_DIP_AVG_BTT         336
//sensor NUC gain row
#define RAM_DIP_GAIN_BUF_ADDR   XPAR_OPENHBMC_0_BASEADDR+336*256*2*5
#define RAM_DIP_GAIN_BTT        336
//sensor NUC offset row
#define RAM_DIP_OFST_BUF_ADDR   XPAR_OPENHBMC_0_BASEADDR+336*256*2*6
#define RAM_DIP_OFST_BTT        336
//equalized image row
#define RAM_DIP_EQUAL_BUF_ADDR  XPAR_OPENHBMC_0_BASEADDR+336*256*2*7
#define RAM_DIP_EQUAL_BTT       84
//equalized image row (x2 upscaled)
#define RAM_DIP_EQUAL2_BUF_ADDR XPAR_OPENHBMC_0_BASEADDR+336*256*2*8
#define RAM_DIP_EQUAL2_BTT      336

//LCD stream, 8bit color per pixel through heatmap?
#define RAM_CH0_PING_ADDR   RAM_DIP_RAW_BUF_ADDR
#define RAM_CH0_PONG_ADDR   RAM_DIP_EQUAL_BUF_ADDR
#define RAM_CH0_BUF_SIZE    320*240
#define RAM_CH0_BTT         320

//LCD OSD only has 16-bit
#define RAM_CH1_PING_ADDR   XPAR_OPENHBMC_0_BASEADDR+336*256*2*10
#define RAM_CH1_PONG_ADDR   XPAR_OPENHBMC_0_BASEADDR+336*256*2*10+320*240*2
#define RAM_CH1_BUF_SIZE    320*240*2
#define RAM_CH1_BTT         320
*/

#endif