#include "vdma.h"
#include "xparameters.h"
#include "xil_io.h"
#include "ram_address.h"

void init_vdma()
{
    Xil_Out32(VDMA_CH0_CONFIG_ADDR, 0x00);
    Xil_Out32(VDMA_CH0_PING_BUF_ADDR_ADDR, RAM_CH0_PING_ADDR);
    Xil_Out32(VDMA_CH0_PONG_BUF_ADDR_ADDR, RAM_CH0_PONG_ADDR);
    Xil_Out32(VDMA_CH0_BUF_SIZE_ADDR, RAM_CH0_BUF_SIZE); // Every pixel 8-bit address ???
    Xil_Out32(VDMA_CH0_ADDR_INCR_ADDR, RAM_CH0_BTT);   // sending 32-bit via data width converter 4 to 1 byte ???
    Xil_Out32(VDMA_CH0_BTT_ADDR, RAM_CH0_BTT);
    Xil_Out32(VDMA_CH1_CONFIG_ADDR, 0x00);
    Xil_Out32(VDMA_CH1_PING_BUF_ADDR_ADDR, RAM_CH1_PING_ADDR);
    Xil_Out32(VDMA_CH1_PONG_BUF_ADDR_ADDR, RAM_CH1_PONG_ADDR);
    Xil_Out32(VDMA_CH1_BUF_SIZE_ADDR, RAM_CH1_BUF_SIZE);  //OSD only has 16-bit
    Xil_Out32(VDMA_CH1_ADDR_INCR_ADDR, RAM_CH1_BTT);   
    Xil_Out32(VDMA_CH1_BTT_ADDR, RAM_CH1_BTT);
    Xil_Out32(VDMA_CH0_CONFIG_ADDR, 0x0f | (0<<30) | (0<<31)); //Set Lastpix | no interlaced mode | Ping buffer
    Xil_Out32(VDMA_CH1_CONFIG_ADDR, 0x0f | (0<<30) | (0<<31)); //Set Lastpix | no interlaced mode | Ping buffer 
}

void enable_vdma()
{
    Xil_Out32(VDMA_CTRL_REG_ADDR, 0b11); //Enable Ch0 and Ch1
}