#ifndef VDMA_H
#define VDMA_H

#include "xparameters.h"

/* Definitions for vdma_ctrl register addresses */
#define VDMA_CTRL_REG_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 0
#define VDMA_STAT_REG_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 4

#define VDMA_CH0_CONFIG_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 8
#define VDMA_CH1_CONFIG_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 12
#define VDMA_CH2_CONFIG_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 16
#define VDMA_CH3_CONFIG_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 20
#define VDMA_CH4_CONFIG_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 24
#define VDMA_CH5_CONFIG_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 28

#define VDMA_CH0_PING_BUF_ADDR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 32
#define VDMA_CH1_PING_BUF_ADDR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 36
#define VDMA_CH2_PING_BUF_ADDR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 40
#define VDMA_CH3_PING_BUF_ADDR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 44
#define VDMA_CH4_PING_BUF_ADDR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 48
#define VDMA_CH5_PING_BUF_ADDR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 52

#define VDMA_CH0_PONG_BUF_ADDR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 56
#define VDMA_CH1_PONG_BUF_ADDR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 60
#define VDMA_CH2_PONG_BUF_ADDR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 64
#define VDMA_CH3_PONG_BUF_ADDR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 68
#define VDMA_CH4_PONG_BUF_ADDR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 72
#define VDMA_CH5_PONG_BUF_ADDR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 76

#define VDMA_CH0_BUF_SIZE_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 80
#define VDMA_CH1_BUF_SIZE_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 84
#define VDMA_CH2_BUF_SIZE_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 88
#define VDMA_CH3_BUF_SIZE_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 92
#define VDMA_CH4_BUF_SIZE_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 96
#define VDMA_CH5_BUF_SIZE_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 100

#define VDMA_CH0_ADDR_INCR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 104
#define VDMA_CH1_ADDR_INCR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 108
#define VDMA_CH2_ADDR_INCR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 112
#define VDMA_CH3_ADDR_INCR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 116
#define VDMA_CH4_ADDR_INCR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 120
#define VDMA_CH5_ADDR_INCR_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 124

#define VDMA_CH0_BTT_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 128
#define VDMA_CH1_BTT_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 132
#define VDMA_CH2_BTT_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 136
#define VDMA_CH3_BTT_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 140
#define VDMA_CH4_BTT_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 144
#define VDMA_CH5_BTT_ADDR XPAR_VDMA_VDMA_CTRL_BASEADDR + 148

void init_vdma();
void enable_vdma();

#endif